
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int main(void){
	int cases;
	cin >> cases;
	while(cases--){
		int amount;
		int d;
		int n;
		cin >> amount >> d >> n;
		vector<pair<int,int> > bonds;
		for(int i=0;i<n;i++){
			int a,b;
			cin >> a >> b;
			bonds.push_back(make_pair(a/1000,b));
		}
		vector<int> data(amount*46/1000+1, 0);
		for(int i=1;i<data.size();i++){
			data[i] = data[i-1];
			for(int j=0;j<n;j++)
				if(bonds[j].first <= i)
					data[i] = max(data[i], data[i-bonds[j].first]+bonds[j].second);
		}
		while(d--)
			amount += data[amount/1000];
		cout << amount << endl;
	}
	return 0;
}
